/**
 * @brief AvP[ṼC _CAO NX̎t@CłB
 * @file  WavToMp3Dlg.cpp
 */

#include "stdafx.h"
#include "WavToMp3.h"
#include "WavToMp3Dlg.h"
#include "afxdialogex.h"
#include "Lame.h"
#include <vector>

// [[N`FbN
#ifdef _DEBUG
	#define new DEBUG_NEW
#endif

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//												t@C [J̎
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

namespace
{
		/**
	 * t@C nhǗ܂B
	 */
	class FileHandle
	{
	public:
		/**
		 * CX^X܂B
		 *
		 * @param fileName t@Cւ̃pXB
		 * @param option   t@C nh̐IvVBfopen ֐̑ɑ܂B
		 */
		FileHandle( LPCTSTR fileName, LPCTSTR option ) : m_file( NULL ), m_isOpened( false )
		{
			this->m_isOpened = ( ::_tfopen_s( &this->m_file, fileName, option ) == 0 );
		}

		/**
		 * CX^X̌ns܂B
		 */
		~FileHandle()
		{
			this->Close();
		}

		/**
		 * FILE |C^ƂĎQƂꂽɌĂяo܂B
		 *
		 * @return t@C nhB
		 */
		operator FILE* () { return this->m_file; }

		/**
		 * const FILE |C^ƂĎQƂꂽɌĂяo܂B
		 *
		 * @return t@C nhB
		 */
		operator const FILE* () const { return this->m_file; }

		/**
		 * t@C nh܂B
		 */
		void Close()
		{
			if( this->IsOpened() )
			{
				::fclose( this->m_file );
				this->m_file     = NULL;
				this->m_isOpened = false;
			}
		}
	
		/**
		 * t@C nhJĂ邱Ƃ𒲂ׂ܂B
		 *
		 * @return JĂꍇ trueBȊO falseB
		 */
		bool IsOpened() { return this->m_isOpened; }

	private:
		FILE* m_file;     //! t@C nhB
		bool  m_isOpened; //! t@C nhJĂ邱ƂlB
	};

	/**
	 * WAV t@C MP3 ɕϊ܂B
	 *
	 * @param src     ϊƂȂ WAV t@Cւ̃pXB
	 * @param dest    ϊƂȂ MP3 t@Cւ̃pXB
	 * @param isVBR   σrbg[gŃGR[hȂ trueBŒȂ falseB
	 * @param bitrate rbg[gBσrbg[g͗vf 0 ŏA21 őB
	 */
	bool ConvertWavToMp3( LPCTSTR src, LPCTSTR dest, bool isVBR, int bitrate[] )
	{
		HBE_STREAM stream  = 0;
		BE_ERR     error   = BE_ERR_SUCCESSFUL;
		DWORD      sizeWav = 0, sizeMp3 = 0;
		{
			BE_CONFIG config = {};
			config.dwConfig                    = BE_CONFIG_LAME;
			config.format.LHV1.dwStructVersion = 1;
			config.format.LHV1.dwStructSize    = sizeof( config );		
			config.format.LHV1.dwSampleRate    = 44100;
			config.format.LHV1.dwReSampleRate  = 0;
			config.format.LHV1.nMode           = BE_MP3_MODE_STEREO;
			config.format.LHV1.dwBitrate       = bitrate[ 0 ];
			config.format.LHV1.dwMaxBitrate    = ( isVBR ? bitrate[ 1 ] : bitrate[ 0 ] );
			config.format.LHV1.nPreset         = ( isVBR ? LQP_NORMAL_QUALITY : LQP_CBR );
			config.format.LHV1.dwMpegVersion   = MPEG1;
			config.format.LHV1.dwPsyModel      = 0;
			config.format.LHV1.dwEmphasis      = 0;
			config.format.LHV1.bOriginal       = TRUE;
			config.format.LHV1.bWriteVBRHeader = FALSE;
			config.format.LHV1.bNoRes          = TRUE;
			config.format.LHV1.bEnableVBR      = TRUE;

			BE_ERR error = Lame::InitStream( &config, &sizeWav, &sizeMp3, &stream );
			if( error != BE_ERR_SUCCESSFUL ) { return false; }
		}

		FileHandle fileIn( src, _T( "rb" ) );
		if( !fileIn.IsOpened() ) { return false; }

		FileHandle fileOut( dest, _T( "wb+" ) );
		if( !fileOut.IsOpened() ) { return false; }

		// WAV ̃t@C |C^ data `N܂Ői߂
		::fseek( fileIn, 44, SEEK_SET );

		std::vector< SHORT > bufferWav( sizeWav );
		std::vector< BYTE  > bufferMp3( sizeMp3 );

		// GR[h
		while( ( sizeWav = ::fread( &bufferWav[ 0 ], sizeof( SHORT ), sizeWav, fileIn ) ) > 0 )
		{
			error = Lame::EncodeChunk( stream, sizeWav, &bufferWav[ 0 ], &bufferMp3[ 0 ], &sizeMp3 );
			if( error != BE_ERR_SUCCESSFUL || ::fwrite( &bufferMp3[ 0 ], 1, sizeMp3, fileOut ) != sizeMp3 )
			{
				Lame::CloseStream( stream );
				return false;
			}
		}
		fileIn.Close();

		// GR[h
		error = Lame::DeinitStream( stream, &bufferMp3[ 0 ], &sizeMp3 );
		if( error != BE_ERR_SUCCESSFUL || ::fwrite( &bufferMp3[ 0 ], 1, sizeMp3, fileOut ) != sizeMp3 )
		{
			Lame::CloseStream( stream );
			return false;
		}
		fileOut.Close();

		if( isVBR )
		{
			Lame::WriteVBRHeader( dest );
		}
		else
		{
			Lame::WriteInfoTag( stream, dest );
		}

		Lame::CloseStream( stream );

		return true;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//													CWavToMp3Dlg ̎
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * CX^X܂B
 *
 * @param pParent eEBhEւ̃|C^Bȗ̋Kl NULLB
 */
CWavToMp3Dlg::CWavToMp3Dlg( CWnd* pParent )
: CDialogEx( CWavToMp3Dlg::IDD, pParent )
{
	this->m_hIcon = ::AfxGetApp()->LoadIcon( IDR_MAINFRAME );
}

////////////////////////////////////////////////////////////////////////////////
//						_CAO \[XƂ̊֘At
////////////////////////////////////////////////////////////////////////////////

// bZ[W}bv
BEGIN_MESSAGE_MAP( CWavToMp3Dlg, CDialogEx )
	ON_BN_CLICKED( IDC_BUTTON_SELECT_SRC, &CWavToMp3Dlg::OnClickedButtonSelectSrc )
	ON_BN_CLICKED( IDC_BUTTON_COVERT,     &CWavToMp3Dlg::OnClickedButtonCovert    )
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
END_MESSAGE_MAP()

/**
 * _CAO \[XƂ̊֘Ats܂B
 *
 * @param pDX _CAO f[^ǗIuWFNgւ̃|C^B
 */
void CWavToMp3Dlg::DoDataExchange( CDataExchange* pDX )
{
	CDialogEx::DoDataExchange( pDX );
}

////////////////////////////////////////////////////////////////////////////////
//							Cxg nh
////////////////////////////////////////////////////////////////////////////////

/**
 * ϊJn{^ꂽɔ܂B
 */
void CWavToMp3Dlg::OnClickedButtonCovert()
{
	CString src;
	this->GetDlgItem( IDC_EDIT_SELECT_SRC )->GetWindowText( src );

	CString dest;
	{
		TCHAR drive[ _MAX_DRIVE ] = {}, dir[ _MAX_DIR ] = {}, fname[ _MAX_FNAME ] = {};
		::_tsplitpath_s( src, drive, _MAX_DRIVE, dir, _MAX_DIR, fname, _MAX_FNAME, NULL, 0 ); 
		dest.Format( _T( "%s%s%s.mp3" ), drive, dir, fname );
	}

	// GR[h
	bool isVBR = false;
	{
		CComboBox* pComboBox = static_cast< CComboBox* >( this->GetDlgItem( IDC_COMBO_ENCODE_MODE ) );
		isVBR = ( pComboBox->GetCurSel() == 1 );
	}

	// rbg[g
	int bitrate[ 2 ] = {};
	{
		CString    text;

		CComboBox* pComboBox = static_cast< CComboBox* >( this->GetDlgItem( IDC_COMBO_BITRATE_MIN ) );
		int min = pComboBox->GetCurSel();

		pComboBox->GetLBText( min, text );
		bitrate[ 0 ] = ::_tstoi( text );

		pComboBox = static_cast< CComboBox* >( this->GetDlgItem( IDC_COMBO_BITRATE_MAX ) );
		int max = pComboBox->GetCurSel();
		if( max < min )
		{
			max = min;
			pComboBox->SetCurSel( max );
		}

		pComboBox->GetLBText( max, text );
		bitrate[ 1 ] = ::_tstoi( text );
	}

	::ConvertWavToMp3( src, dest, isVBR, bitrate );
}

/**
 * t@CI{^ꂽɔ܂B
 */
void CWavToMp3Dlg::OnClickedButtonSelectSrc()
{
	CFileDialog dialog( TRUE, NULL, NULL, 0, _T( "WAV Files(*.wav)|*.wav|" ), this );
	if( dialog.DoModal() == IDOK )
	{
		this->GetDlgItem( IDC_EDIT_SELECT_SRC )->SetWindowText( dialog.GetPathName() );
		this->GetDlgItem( IDC_BUTTON_COVERT )->EnableWindow();
	}
}

/**
 * _CAO鎞ɔ܂B
 *
 * @return  TRUEBȊO FALSEB
 */
BOOL CWavToMp3Dlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();
	this->SetIcon( this->m_hIcon, TRUE  );
	this->SetIcon( this->m_hIcon, FALSE );

	this->GetDlgItem( IDC_BUTTON_COVERT )->EnableWindow( FALSE );
	
	// rbg[g VBR 128kbps ` 160kbps
	{
		CComboBox* pComboBox = static_cast< CComboBox* >( this->GetDlgItem( IDC_COMBO_BITRATE_MIN ) );
		pComboBox->SetCurSel( 8 );

		pComboBox = static_cast< CComboBox* >( this->GetDlgItem( IDC_COMBO_BITRATE_MAX ) );
		pComboBox->SetCurSel( 9 );

		pComboBox = static_cast< CComboBox* >( this->GetDlgItem( IDC_COMBO_ENCODE_MODE ) );
		pComboBox->SetCurSel( 1 );
	}

	return TRUE;
}

/**
 * ĕ`悪KvɂȂɔ܂B
 */
void CWavToMp3Dlg::OnPaint()
{
	if( this->IsIconic() )
	{
		CPaintDC dc( this );
		this->SendMessage( WM_ICONERASEBKGND, reinterpret_cast< WPARAM >( dc.GetSafeHdc() ), 0 );

		// NCAg̎lp`̈̒
		CRect rect;
		this->GetClientRect(&rect);
		
		const int iconX = ::GetSystemMetrics( SM_CXICON );
		const int iconY = ::GetSystemMetrics( SM_CYICON );
		const int x = ( rect.Width()  - iconX + 1 ) / 2;
		const int y = ( rect.Height() - iconY + 1 ) / 2;

		// ACR̕`
		dc.DrawIcon( x, y, this->m_hIcon );
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

/**
 * [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁAVXe̊֐Ăяo܂B
 *
 * @return J[\B
 */
HCURSOR CWavToMp3Dlg::OnQueryDragIcon()
{
	return static_cast< HCURSOR >( this->m_hIcon );
}
